"use strict"

function calculate(x) {
  // ... 计算过程的代码

//   console.log("十分耗费性能！！！");
  return x;
}

// calculate(1); // 十分耗费性能！！！
// calculate(2); // 十分耗费性能！！！

// // 计算缓存 - 装饰器
// function cachingDecorator(fn) {
//   // 我们用 map 结构来保存数据
//   const cache = new Map();
// }

// 计算缓存 - 装饰器
function cachingDecorator(fn) {
  // 我们用 map 结构来保存数据
  const cache = new Map();

  // 返回一个函数
  return function (x) {
    // 从缓存中读取
    if (cache.has(x)) {
      // 为了大家能方便的看到效果增加一条输出语句
      console.log(`从缓存中读取：${cache.get(x)}`);
      return cache.get(x);
    }
    // 执行
    // const result = fn.call(this, x);
    const result = fn(x);

    // 为了大家能方便的看到效果增加一条输出语句
    console.log(`新值：${result}`);

    // 把新的值存入缓存
    cache.set(x, result);

    return result;
  };
}

const excute = cachingDecorator(calculate);

// excute(1); // 新值：1
// excute(1); // 从缓存中读取：1
// excute(1); // 从缓存中读取：1
// excute(2); // 新值：2
// excute(2); // 从缓存中读取：2

// const work = {
//     calculate() {
//         return 1;
//     },

//     slow(x) {
//         // ... 这里省略了大量的计算任务
//         return x * this.calculate();
//     }
// }
// console.log( work.slow(1) ); // 1
// console.log( work.slow(2) ); // 2
// work.slow = cachingDecorator(work.slow);
// work.slow(1);
// work.slow(1);