function printf1(e) {
  document.getElementById("p1").innerText = e.target.value;
}

document.getElementById("input1").addEventListener("input", function (e) {
  printf1(e);
});

function printf2(e) {
  document.getElementById("p2").innerText = e.target.value;
}

function debounce(func, ms) {
  // 记录计时器
  let timeout = null;

  // 通过闭包隐藏 debounce 函数内部变量，避免外部意外修改
  return function () {
    // 清除计时器
    clearTimeout(timeout);

    // 通过 setTimeout 实现延迟执行 func 函数
    timeout = setTimeout(() => func.apply(this, arguments), ms);
  };
}

document.getElementById("input2").addEventListener("input", (e) => {
  debounce(printf2, 1000)(e);
});
