// 1.定时器版本
function throttle1(fn, delay) {
  if (typeof fn !== "function") throw new Error("first param need a function");
  if (typeof wait !== "number") throw new Error("second param need a number");
  let timer = null;
  return function () {
    if (timer) {
      return;
    }
    timer = setTimeout(() => {
      fn.apply(this, arguments);
      timer = null;
    }, delay);
  };
}

// 2.时间戳版本
function throttle2(fn, delay) {
  if (typeof fn !== "function") throw new Error("first param need a function");
  if (typeof delay !== "number") throw new Error("second param need a number");
  let startTime = 0;
  return function () {
    let currentTime = new Date().getTime();
    if (currentTime - startTime > delay) {
      fn.apply(this, arguments);
      startTime = currentTime;
    }
  };
}
